MessageOrBuilder
Date: 2017-07-08

com.google.protobuf

## Interface MessageOrBuilder

- All Superinterfaces:
    MessageLiteOrBuilder
  All Known Subinterfaces:
    DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder, DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder, DescriptorProtos.DescriptorProtoOrBuilder, DescriptorProtos.EnumDescriptorProtoOrBuilder, DescriptorProtos.EnumOptionsOrBuilder, DescriptorProtos.EnumValueDescriptorProtoOrBuilder, DescriptorProtos.EnumValueOptionsOrBuilder, DescriptorProtos.FieldDescriptorProtoOrBuilder, DescriptorProtos.FieldOptionsOrBuilder, DescriptorProtos.FileDescriptorProtoOrBuilder, DescriptorProtos.FileDescriptorSetOrBuilder, DescriptorProtos.FileOptionsOrBuilder, DescriptorProtos.GeneratedCodeInfo.AnnotationOrBuilder, DescriptorProtos.GeneratedCodeInfoOrBuilder, DescriptorProtos.MessageOptionsOrBuilder, DescriptorProtos.MethodDescriptorProtoOrBuilder, DescriptorProtos.MethodOptionsOrBuilder, DescriptorProtos.OneofDescriptorProtoOrBuilder, DescriptorProtos.OneofOptionsOrBuilder, DescriptorProtos.ServiceDescriptorProtoOrBuilder, DescriptorProtos.ServiceOptionsOrBuilder, DescriptorProtos.SourceCodeInfo.LocationOrBuilder, DescriptorProtos.SourceCodeInfoOrBuilder, DescriptorProtos.UninterpretedOption.NamePartOrBuilder, DescriptorProtos.UninterpretedOptionOrBuilder, GeneratedMessage.ExtendableMessageOrBuilder<MessageType>, GeneratedMessageV3.ExtendableMessageOrBuilder<MessageType>, Message, Message.Builder
  All Known Implementing Classes:
    AbstractMessage, AbstractMessage.Builder, DescriptorProtos.DescriptorProto, DescriptorProtos.DescriptorProto.Builder, DescriptorProtos.DescriptorProto.ExtensionRange, DescriptorProtos.DescriptorProto.ExtensionRange.Builder, DescriptorProtos.DescriptorProto.ReservedRange, DescriptorProtos.DescriptorProto.ReservedRange.Builder, DescriptorProtos.EnumDescriptorProto, DescriptorProtos.EnumDescriptorProto.Builder, DescriptorProtos.EnumOptions, DescriptorProtos.EnumOptions.Builder, DescriptorProtos.EnumValueDescriptorProto, DescriptorProtos.EnumValueDescriptorProto.Builder, DescriptorProtos.EnumValueOptions, DescriptorProtos.EnumValueOptions.Builder, DescriptorProtos.FieldDescriptorProto, DescriptorProtos.FieldDescriptorProto.Builder, DescriptorProtos.FieldOptions, DescriptorProtos.FieldOptions.Builder, DescriptorProtos.FileDescriptorProto, DescriptorProtos.FileDescriptorProto.Builder, DescriptorProtos.FileDescriptorSet, DescriptorProtos.FileDescriptorSet.Builder, DescriptorProtos.FileOptions, DescriptorProtos.FileOptions.Builder, DescriptorProtos.GeneratedCodeInfo, DescriptorProtos.GeneratedCodeInfo.Annotation, DescriptorProtos.GeneratedCodeInfo.Annotation.Builder, DescriptorProtos.GeneratedCodeInfo.Builder, DescriptorProtos.MessageOptions, DescriptorProtos.MessageOptions.Builder, DescriptorProtos.MethodDescriptorProto, DescriptorProtos.MethodDescriptorProto.Builder, DescriptorProtos.MethodOptions, DescriptorProtos.MethodOptions.Builder, DescriptorProtos.OneofDescriptorProto, DescriptorProtos.OneofDescriptorProto.Builder, DescriptorProtos.OneofOptions, DescriptorProtos.OneofOptions.Builder, DescriptorProtos.ServiceDescriptorProto, DescriptorProtos.ServiceDescriptorProto.Builder, DescriptorProtos.ServiceOptions, DescriptorProtos.ServiceOptions.Builder, DescriptorProtos.SourceCodeInfo, DescriptorProtos.SourceCodeInfo.Builder, DescriptorProtos.SourceCodeInfo.Location, DescriptorProtos.SourceCodeInfo.Location.Builder, DescriptorProtos.UninterpretedOption, DescriptorProtos.UninterpretedOption.Builder, DescriptorProtos.UninterpretedOption.NamePart, DescriptorProtos.UninterpretedOption.NamePart.Builder, DynamicMessage, DynamicMessage.Builder, GeneratedMessage, GeneratedMessage.Builder, GeneratedMessage.ExtendableBuilder, GeneratedMessage.ExtendableMessage, GeneratedMessageV3, GeneratedMessageV3.Builder, GeneratedMessageV3.ExtendableBuilder, GeneratedMessageV3.ExtendableMessage, MapEntry, MapEntry.Builder

      public interface MessageOrBuilder
      extends MessageLiteOrBuilder

  Base interface for methods common to `Message` and `Message.Builder` to provide type equivalency.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.List<java.lang.String>` | `findInitializationErrors()` Returns a list of field paths (e.g.
    `java.util.Map<Descriptors.FieldDescriptor,java.lang.Object>` | `getAllFields()` Returns a collection of all the fields in this message which are set and their corresponding values.
    `Message` | `getDefaultInstanceForType()` Get an instance of the type with no fields set.
    `Descriptors.Descriptor` | `getDescriptorForType()` Get the message's type's descriptor.
    `java.lang.Object` | `getField(Descriptors.FieldDescriptor field)` Obtains the value of the given field, or the default value if it is not set.
    `java.lang.String` | `getInitializationErrorString()` Returns a comma-delimited list of required fields which are not set in this message object.
    `Descriptors.FieldDescriptor` | `getOneofFieldDescriptor(Descriptors.OneofDescriptor oneof)` Obtains the FieldDescriptor if the given oneof is set.
    `java.lang.Object` | `getRepeatedField(Descriptors.FieldDescriptor field, int index)` Gets an element of a repeated field.
    `int` | `getRepeatedFieldCount(Descriptors.FieldDescriptor field)` Gets the number of elements of a repeated field.
    `UnknownFieldSet` | `getUnknownFields()` Get the `UnknownFieldSet` for this message.
    `boolean` | `hasField(Descriptors.FieldDescriptor field)` Returns true if the given field is set.
    `boolean` | `hasOneof(Descriptors.OneofDescriptor oneof)` Returns true if the given oneof is set.

    - ### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

      `isInitialized`

- - ### Method Detail

    - #### getDefaultInstanceForType

          Message getDefaultInstanceForType()

      Description copied from interface: `MessageLiteOrBuilder`
      Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.
      Specified by:
        `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`

    - #### findInitializationErrors

          java.util.List<java.lang.String> findInitializationErrors()

      Returns a list of field paths (e.g. "foo.bar.baz") of required fields which are not set in this message. You should call `MessageLiteOrBuilder.isInitialized()` first to check if there are any missing fields, as that method is likely to be much faster than this one even when the message is fully-initialized.

    - #### getInitializationErrorString

          java.lang.String getInitializationErrorString()

      Returns a comma-delimited list of required fields which are not set in this message object. You should call `MessageLiteOrBuilder.isInitialized()` first to check if there are any missing fields, as that method is likely to be much faster than this one even when the message is fully-initialized.

    - #### getDescriptorForType

          Descriptors.Descriptor getDescriptorForType()

      Get the message's type's descriptor. This differs from the `getDescriptor()` method of generated message classes in that this method is an abstract method of the `Message` interface whereas `getDescriptor()` is a static method of a specific class. They return the same thing.

    - #### getAllFields

          java.util.Map<Descriptors.FieldDescriptor,java.lang.Object> getAllFields()

      Returns a collection of all the fields in this message which are set and their corresponding values. A singular ("required" or "optional") field is set iff hasField() returns true for that field. A "repeated" field is set iff getRepeatedFieldCount() is greater than zero. The values are exactly what would be returned by calling `getField(Descriptors.FieldDescriptor)` for each field. The map is guaranteed to be a sorted map, so iterating over it will return fields in order by field number.
      If this is for a builder, the returned map may or may not reflect future changes to the builder. Either way, the returned map is itself unmodifiable.

    - #### hasOneof

          boolean hasOneof(Descriptors.OneofDescriptor oneof)

      Returns true if the given oneof is set.
      Throws:
        `java.lang.IllegalArgumentException` - if `oneof.getContainingType() != getDescriptorForType()`.

    - #### getOneofFieldDescriptor

          Descriptors.FieldDescriptor getOneofFieldDescriptor(Descriptors.OneofDescriptor oneof)

      Obtains the FieldDescriptor if the given oneof is set. Returns null if no field is set.

    - #### hasField

          boolean hasField(Descriptors.FieldDescriptor field)

      Returns true if the given field is set. This is exactly equivalent to calling the generated "has" accessor method corresponding to the field.
      Throws:
        `java.lang.IllegalArgumentException` - The field is a repeated field, or `field.getContainingType() != getDescriptorForType()`.

    - #### getField

          java.lang.Object getField(Descriptors.FieldDescriptor field)

      Obtains the value of the given field, or the default value if it is not set. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned. For repeated fields, a java.util.List is returned.

    - #### getRepeatedFieldCount

          int getRepeatedFieldCount(Descriptors.FieldDescriptor field)

      Gets the number of elements of a repeated field. This is exactly equivalent to calling the generated "Count" accessor method corresponding to the field.
      Throws:
        `java.lang.IllegalArgumentException` - The field is not a repeated field, or `field.getContainingType() != getDescriptorForType()`.

    - #### getRepeatedField

          java.lang.Object getRepeatedField(Descriptors.FieldDescriptor field,
                                          int index)

      Gets an element of a repeated field. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned.
      Throws:
        `java.lang.IllegalArgumentException` - The field is not a repeated field, or `field.getContainingType() != getDescriptorForType()`.

    - #### getUnknownFields

          UnknownFieldSet getUnknownFields()

      Get the `UnknownFieldSet` for this message.